WebShell Manager
Linux Stag-Enterprise-Staging-20-04 5.11.0-1019-aws #20~20.04.1-Ubuntu SMP Tue Sep 21 10:40:39 UTC 2021 x86_64
Apache
Server: 172.31.9.152
Your IP: 216.73.216.254
System Info
HOME
snap
core18
2999
usr
bin
Command Execution
Execute
File Upload
Upload
New Folder
New File
Name
Type
Size
Permissions
Modified
Actions
..
Parent
-
drwxr-xr-x
2026-02-04 00:15:22
-
[
File
50.18 KB
0755
2018-01-18 09:43:49
aa-enabled
File
22.16 KB
0755
2023-06-13 14:19:14
aa-exec
File
22.16 KB
0755
2023-06-13 14:19:14
addpart
File
22.08 KB
0755
2020-09-16 18:43:15
apt
File
77 B
0755
2026-02-04 00:13:24
apt-cache
File
77 B
0755
2026-02-04 00:13:24
apt-get
File
77 B
0755
2026-02-04 00:13:24
arch
File
34.21 KB
0755
2018-01-18 09:43:49
awk
File
122.48 KB
0755
2018-04-03 12:34:18
b2sum
File
54.21 KB
0755
2018-01-18 09:43:49
base32
File
38.18 KB
0755
2018-01-18 09:43:49
base64
File
38.18 KB
0755
2018-01-18 09:43:49
basename
File
34.18 KB
0755
2018-01-18 09:43:49
bashbug
File
6.95 KB
0755
2022-04-18 15:08:18
bootctl
File
34.13 KB
0755
2024-08-16 14:54:17
busctl
File
66.09 KB
0755
2024-08-16 14:54:17
c_rehash
File
6.65 KB
0755
2026-01-14 19:45:12
captoinfo
File
82.11 KB
0755
2024-03-06 14:37:58
catchsegv
File
3.26 KB
0755
2026-01-30 08:03:29
cautious-launcher
File
853 B
0755
2016-07-15 12:06:12
chage
File
70.13 KB
2755
2024-02-06 12:31:54
chardet3
File
389 B
0755
2017-06-18 21:51:08
chardetect3
File
389 B
0755
2017-06-18 21:51:08
chattr
File
14 KB
0755
2022-06-02 14:37:00
chcon
File
62.18 KB
0755
2018-01-18 09:43:49
chfn
File
74.7 KB
4755
2024-02-06 12:31:54
chrt
File
30.08 KB
0755
2020-09-16 18:43:15
chsh
File
43.48 KB
4755
2024-02-06 12:31:54
cksum
File
34.18 KB
0755
2018-01-18 09:43:49
clear
File
10 KB
0755
2024-03-06 14:37:58
clear_console
File
10.07 KB
0755
2022-04-18 15:08:18
cloud-id
File
396 B
0755
2025-06-25 21:46:01
cloud-init
File
400 B
0755
2025-06-25 21:46:01
cloud-init-per
File
2.06 KB
0755
2023-04-20 21:31:09
cmp
File
46.09 KB
0755
2017-08-04 21:20:16
comm
File
38.21 KB
0755
2018-01-18 09:43:49
compose
File
17.74 KB
0755
2016-07-15 12:06:12
console-conf
File
2.86 KB
0755
2020-07-22 14:34:46
core-sshd-host-keygen
File
1.53 KB
0755
2026-02-04 00:11:12
csplit
File
50.21 KB
0755
2018-01-18 09:43:49
ctstat
File
22.35 KB
0755
2021-01-26 13:33:08
cut
File
42.21 KB
0755
2018-01-18 09:43:49
dbus-cleanup-sockets
File
9.98 KB
0755
2022-10-25 13:03:19
dbus-daemon
File
231.04 KB
0755
2022-10-25 13:03:19
dbus-monitor
File
21.99 KB
0755
2022-10-25 13:03:19
dbus-run-session
File
9.98 KB
0755
2022-10-25 13:03:19
dbus-send
File
25.98 KB
0755
2022-10-25 13:03:19
dbus-update-activation-environment
File
13.98 KB
0755
2022-10-25 13:03:19
dbus-uuidgen
File
9.98 KB
0755
2022-10-25 13:03:19
deb-systemd-helper
File
19.67 KB
0755
2017-10-25 15:38:42
deb-systemd-invoke
File
4.33 KB
0755
2017-10-25 15:38:42
delpart
File
22.08 KB
0755
2020-09-16 18:43:15
dh_bash-completion
File
2.49 KB
0755
2018-04-02 02:16:46
diff
File
142.34 KB
0755
2017-08-04 21:20:16
diff3
File
62.21 KB
0755
2017-08-04 21:20:16
dircolors
File
46.19 KB
0755
2018-01-18 09:43:49
dirname
File
30.18 KB
0755
2018-01-18 09:43:49
dpkg-deb
File
150.34 KB
0755
2022-05-25 11:14:56
du
File
98.21 KB
0755
2018-01-18 09:43:49
ec2metadata
File
7.13 KB
0755
2018-04-13 13:07:55
edit
File
17.74 KB
0755
2016-07-15 12:06:12
editor
File
1.06 MB
0755
2025-10-02 22:59:18
env
File
34.18 KB
0755
2018-01-18 09:43:49
ex
File
1.06 MB
0755
2025-10-02 22:59:18
expand
File
38.21 KB
0755
2018-01-18 09:43:49
expiry
File
22.27 KB
2755
2024-02-06 12:31:54
expr
File
46.18 KB
0755
2018-01-18 09:43:49
factor
File
74.21 KB
0755
2018-01-18 09:43:49
faillog
File
18.29 KB
0755
2024-02-06 12:31:54
fallocate
File
26.08 KB
0755
2020-09-16 18:43:15
finalrd
File
2.1 KB
0755
2020-09-10 14:54:08
find
File
232.5 KB
0755
2017-11-05 17:16:48
flock
File
30.16 KB
0755
2020-09-16 18:43:15
fmt
File
42.18 KB
0755
2018-01-18 09:43:49
fold
File
34.18 KB
0755
2018-01-18 09:43:49
free
File
18.08 KB
0755
2023-10-31 11:35:42
gdbserver
File
645.52 KB
0755
2024-06-13 03:15:46
getconf
File
30.13 KB
0755
2026-01-30 08:03:29
getent
File
30.49 KB
0755
2026-01-30 08:03:29
getopt
File
14.07 KB
0755
2020-09-16 18:43:15
gpasswd
File
74.05 KB
4755
2024-02-06 12:31:54
gpgv
File
431.02 KB
0755
2026-01-06 11:28:10
groups
File
34.18 KB
0755
2018-01-18 09:43:49
growpart
File
21.37 KB
0755
2018-04-13 13:07:55
head
File
42.21 KB
0755
2018-01-18 09:43:49
helpztags
File
2.46 KB
0755
2024-08-27 05:37:55
hostid
File
30.18 KB
0755
2018-01-18 09:43:49
hostnamectl
File
18.07 KB
0755
2024-08-16 14:54:17
i386
File
18.34 KB
0755
2020-09-16 18:43:15
iconv
File
62.25 KB
0755
2026-01-30 08:03:29
id
File
42.21 KB
0755
2018-01-18 09:43:49
infocmp
File
58.07 KB
0755
2024-03-06 14:37:58
infotocap
File
82.11 KB
0755
2024-03-06 14:37:58
install
File
142.25 KB
0755
2018-01-18 09:43:49
ionice
File
26.08 KB
0755
2020-09-16 18:43:15
ipcmk
File
26.14 KB
0755
2020-09-16 18:43:15
ipcrm
File
26.08 KB
0755
2020-09-16 18:43:15
ipcs
File
50.08 KB
0755
2020-09-16 18:43:15
iptables-xml
File
0 B
0
1970-01-01 00:00:00
ischroot
File
10.04 KB
0755
2017-12-30 18:15:02
join
File
46.21 KB
0755
2018-01-18 09:43:49
jsondiff
File
1018 B
0755
2017-10-28 20:10:15
jsonpatch
File
3.58 KB
0755
2017-10-28 20:10:15
jsonpointer
File
1.31 KB
0755
2016-05-01 23:14:11
jsonschema
File
398 B
0755
2017-11-15 19:43:29
kernel-install
File
4.4 KB
0755
2018-01-28 15:58:17
last
File
42.08 KB
0755
2020-09-16 18:43:15
lastb
File
42.08 KB
0755
2020-09-16 18:43:15
lastlog
File
18.07 KB
0755
2024-02-06 12:31:54
lcf
File
7.6 KB
0755
2018-02-26 00:58:23
ldd
File
5.3 KB
0755
2026-01-30 08:03:29
less
File
175.84 KB
0755
2024-04-28 11:42:44
lessecho
File
14.31 KB
0755
2024-04-28 11:42:44
lessfile
File
8.36 KB
0755
2019-09-03 04:41:52
lesskey
File
23.72 KB
0755
2024-04-28 11:42:44
lesspipe
File
8.36 KB
0755
2019-09-03 04:41:52
link
File
30.18 KB
0755
2018-01-18 09:43:49
linux32
File
18.34 KB
0755
2020-09-16 18:43:15
linux64
File
18.34 KB
0755
2020-09-16 18:43:15
lnstat
File
22.35 KB
0755
2021-01-26 13:33:08
locale
File
49.41 KB
0755
2026-01-30 08:03:29
locale-check
File
10 KB
0755
2024-01-02 17:19:18
localectl
File
22.07 KB
0755
2024-08-16 14:54:17
localedef
File
330.8 KB
0755
2026-01-30 08:03:29
logger
File
46.67 KB
0755
2020-09-16 18:43:15
logname
File
30.18 KB
0755
2018-01-18 09:43:49
lsattr
File
10 KB
0755
2022-06-02 14:37:00
lscpu
File
70.08 KB
0755
2020-09-16 18:43:15
lsipc
File
70.08 KB
0755
2020-09-16 18:43:15
lslocks
File
34.41 KB
0755
2020-09-16 18:43:15
lslogins
File
62.08 KB
0755
2020-09-16 18:43:15
lsmem
File
42.08 KB
0755
2020-09-16 18:43:15
lsns
File
38.08 KB
0755
2020-09-16 18:43:15
mawk
File
122.48 KB
0755
2018-04-03 12:34:18
mcookie
File
30.14 KB
0755
2020-09-16 18:43:15
md5sum
File
42.21 KB
0755
2018-01-18 09:43:49
md5sum.textutils
File
42.21 KB
0755
2018-01-18 09:43:49
mesg
File
10.07 KB
0755
2020-09-16 18:43:15
miniterm
File
34.28 KB
0755
2018-04-09 11:57:25
mkfifo
File
62.18 KB
0755
2018-01-18 09:43:49
mksquashfs
File
184.99 KB
0755
2021-09-14 08:43:17
mkswapfile
File
865 B
0755
2026-02-04 00:11:12
namei
File
26.08 KB
0755
2020-09-16 18:43:15
nawk
File
122.48 KB
0755
2018-04-03 12:34:18
newgrp
File
39.4 KB
4755
2024-02-06 12:31:54
nice
File
34.18 KB
0755
2018-01-18 09:43:49
nl
File
42.27 KB
0755
2018-01-18 09:43:49
no-apt
File
77 B
0755
2026-02-04 00:13:24
nohup
File
34.18 KB
0755
2018-01-18 09:43:49
nproc
File
34.18 KB
0755
2018-01-18 09:43:49
nsenter
File
30.28 KB
0755
2020-09-16 18:43:15
nstat
File
26.07 KB
0755
2021-01-26 13:33:08
numfmt
File
62.24 KB
0755
2018-01-18 09:43:49
od
File
66.21 KB
0755
2018-01-18 09:43:49
openssl
File
706.98 KB
0755
2026-01-14 19:45:12
pager
File
166.76 KB
0755
2024-04-28 11:42:19
partx
File
86.08 KB
0755
2020-09-16 18:43:15
passwd
File
58.24 KB
4755
2024-02-06 12:31:54
paste
File
34.21 KB
0755
2018-01-18 09:43:49
pathchk
File
34.18 KB
0755
2018-01-18 09:43:49
pdb3
File
59.87 KB
0755
2025-11-18 13:14:54
pdb3.6
File
59.87 KB
0755
2025-11-18 13:14:54
perl
File
2 MB
0755
2023-05-23 17:17:19
perl5.26.1
File
2 MB
0755
2023-05-23 17:17:19
pgrep
File
26.09 KB
0755
2023-10-31 11:35:42
pinky
File
38.21 KB
0755
2018-01-18 09:43:49
pkill
File
26.09 KB
0755
2023-10-31 11:35:42
pldd
File
14.22 KB
0755
2026-01-30 08:03:29
pmap
File
30.09 KB
0755
2023-10-31 11:35:42
pr
File
70.27 KB
0755
2018-01-18 09:43:49
print
File
17.74 KB
0755
2016-07-15 12:06:12
printenv
File
30.18 KB
0755
2018-01-18 09:43:49
printf
File
50.18 KB
0755
2018-01-18 09:43:49
prlimit
File
34.59 KB
0755
2020-09-16 18:43:15
probert
File
2.09 KB
0755
2018-10-15 10:49:55
ptx
File
70.24 KB
0755
2018-01-18 09:43:49
pwdx
File
10.07 KB
0755
2023-10-31 11:35:42
py3clean
File
7.63 KB
0755
2018-10-25 11:11:00
py3compile
File
11.83 KB
0755
2018-10-25 11:11:00
py3versions
File
11.44 KB
0755
2018-10-25 11:11:00
pydoc3
File
79 B
0755
2025-11-18 13:14:54
pydoc3.6
File
79 B
0755
2025-11-18 13:14:54
pygettext3
File
21.04 KB
0755
2025-11-18 13:14:54
pygettext3.6
File
21.04 KB
0755
2025-11-18 13:14:54
pyjwt3
File
372 B
0755
2022-07-19 06:23:32
python3
File
4.32 MB
0755
2025-11-18 13:14:54
python3-jsondiff
File
1018 B
0755
2017-10-28 20:10:15
python3-jsonpatch
File
3.58 KB
0755
2017-10-28 20:10:15
python3-jsonpointer
File
1.31 KB
0755
2016-05-01 23:14:11
python3-jsonschema
File
398 B
0755
2017-11-15 19:43:29
python3.6
File
4.32 MB
0755
2025-11-18 13:14:54
python3.6m
File
4.32 MB
0755
2025-11-18 13:14:54
python3m
File
4.32 MB
0755
2025-11-18 13:14:54
rcp
File
98.14 KB
0755
2025-02-18 13:44:19
rdma
File
26.07 KB
0755
2021-01-26 13:33:08
realpath
File
46.21 KB
0755
2018-01-18 09:43:49
rename.ul
File
14.07 KB
0755
2020-09-16 18:43:15
renice
File
14.07 KB
0755
2020-09-16 18:43:15
reset
File
22 KB
0755
2024-03-06 14:37:58
resizepart
File
38.08 KB
0755
2020-09-16 18:43:15
rev
File
10.07 KB
0755
2020-09-16 18:43:15
rgrep
File
30 B
0755
2017-07-11 13:19:59
rlogin
File
710.79 KB
0755
2025-02-18 13:44:19
routef
File
208 B
0755
2021-01-26 13:33:08
routel
File
1.62 KB
0755
2021-01-26 13:33:08
rsh
File
710.79 KB
0755
2025-02-18 13:44:19
rtstat
File
22.35 KB
0755
2021-01-26 13:33:08
run-mailcap
File
17.74 KB
0755
2016-07-15 12:06:12
runcon
File
34.18 KB
0755
2018-01-18 09:43:49
rview
File
1.06 MB
0755
2025-10-02 22:59:18
savelog
File
10.22 KB
0755
2017-12-30 18:15:02
scp
File
98.14 KB
0755
2025-02-18 13:44:19
script
File
30.07 KB
0755
2020-09-16 18:43:15
scriptreplay
File
26.08 KB
0755
2020-09-16 18:43:15
sdiff
File
50.09 KB
0755
2017-08-04 21:20:16
see
File
17.74 KB
0755
2016-07-15 12:06:12
select-editor
File
2.38 KB
0755
2018-03-12 10:17:53
sensible-browser
File
1.18 KB
0755
2018-03-12 10:17:53
sensible-editor
File
1.08 KB
0755
2018-03-12 10:17:53
sensible-pager
File
433 B
0755
2018-03-12 10:17:53
seq
File
46.18 KB
0755
2018-01-18 09:43:49
setarch
File
18.34 KB
0755
2020-09-16 18:43:15
setsid
File
10.07 KB
0755
2020-09-16 18:43:15
setterm
File
42.08 KB
0755
2020-09-16 18:43:15
sftp
File
150.35 KB
0755
2025-02-18 13:44:19
sg
File
39.4 KB
4755
2024-02-06 12:31:54
sha1sum
File
46.21 KB
0755
2018-01-18 09:43:49
sha224sum
File
54.21 KB
0755
2018-01-18 09:43:49
sha256sum
File
54.21 KB
0755
2018-01-18 09:43:49
sha384sum
File
58.21 KB
0755
2018-01-18 09:43:49
sha512sum
File
58.21 KB
0755
2018-01-18 09:43:49
shred
File
58.21 KB
0755
2018-01-18 09:43:49
shuf
File
54.18 KB
0755
2018-01-18 09:43:49
skill
File
26.08 KB
0755
2023-10-31 11:35:42
slabtop
File
18.08 KB
0755
2023-10-31 11:35:42
slogin
File
710.79 KB
0755
2025-02-18 13:44:19
snap
File
22.43 MB
0755
2026-06-29 12:01:19
snapctl
File
0 B
0
1970-01-01 00:00:00
snice
File
26.08 KB
0755
2023-10-31 11:35:42
sort
File
110.47 KB
0755
2018-01-18 09:43:49
split
File
54.63 KB
0755
2018-01-18 09:43:49
ssh
File
710.79 KB
0755
2025-02-18 13:44:19
ssh-add
File
338.13 KB
0755
2025-02-18 13:44:19
ssh-agent
File
354.14 KB
2755
2025-02-18 13:44:19
ssh-argv0
File
1.42 KB
0755
2022-03-30 13:17:14
ssh-copy-id
File
10.41 KB
0755
2017-10-02 19:34:26
ssh-keygen
File
410.16 KB
0755
2025-02-18 13:44:19
ssh-keyscan
File
414.16 KB
0755
2025-02-18 13:44:19
stat
File
78.21 KB
0755
2018-01-18 09:43:49
stdbuf
File
46.18 KB
0755
2018-01-18 09:43:49
sudo
File
145.59 KB
4755
2025-06-25 20:14:55
sudoedit
File
145.59 KB
4755
2025-06-25 20:14:55
sudoreplay
File
54.81 KB
0755
2025-06-25 20:14:55
sum
File
38.19 KB
0755
2018-01-18 09:43:49
systemd-analyze
File
1.49 MB
0755
2024-08-16 14:54:17
systemd-cat
File
10.07 KB
0755
2024-08-16 14:54:17
systemd-cgls
File
14.07 KB
0755
2024-08-16 14:54:17
systemd-cgtop
File
30.09 KB
0755
2024-08-16 14:54:17
systemd-delta
File
22.07 KB
0755
2024-08-16 14:54:17
systemd-detect-virt
File
10.06 KB
0755
2024-08-16 14:54:17
systemd-mount
File
42.09 KB
0755
2024-08-16 14:54:17
systemd-path
File
10.06 KB
0755
2024-08-16 14:54:17
systemd-resolve
File
86.07 KB
0755
2024-08-16 14:54:17
systemd-run
File
42.07 KB
0755
2024-08-16 14:54:17
systemd-socket-activate
File
18.07 KB
0755
2024-08-16 14:54:17
systemd-stdio-bridge
File
14.07 KB
0755
2024-08-16 14:54:17
systemd-umount
File
42.09 KB
0755
2024-08-16 14:54:17
tabs
File
13.99 KB
0755
2024-03-06 14:37:58
tac
File
38.18 KB
0755
2018-01-18 09:43:49
tail
File
66.24 KB
0755
2018-01-18 09:43:49
taskset
File
30.08 KB
0755
2020-09-16 18:43:15
tee
File
34.21 KB
0755
2018-01-18 09:43:49
test
File
46.18 KB
0755
2018-01-18 09:43:49
tic
File
82.11 KB
0755
2024-03-06 14:37:58
timedatectl
File
815 B
0755
2026-02-04 00:13:23
timedatectl.real
File
22.07 KB
0755
2024-08-16 14:54:17
timeout
File
38.63 KB
0755
2018-01-18 09:43:49
tload
File
14.09 KB
0755
2023-10-31 11:35:42
toe
File
13.99 KB
0755
2024-03-06 14:37:58
top
File
105.77 KB
0755
2023-10-31 11:35:42
touch
File
98.37 KB
0755
2019-09-05 10:38:40
tput
File
18.02 KB
0755
2024-03-06 14:37:58
tr
File
46.18 KB
0755
2018-01-18 09:43:49
truncate
File
38.18 KB
0755
2018-01-18 09:43:49
tset
File
22 KB
0755
2024-03-06 14:37:58
tsort
File
34.18 KB
0755
2018-01-18 09:43:49
tty
File
30.18 KB
0755
2018-01-18 09:43:49
tzselect
File
15.04 KB
0755
2026-01-30 08:03:29
ucf
File
39.73 KB
0755
2018-02-26 00:58:23
ucfq
File
18.91 KB
0755
2018-02-26 00:58:23
ucfr
File
10.47 KB
0755
2018-02-26 00:58:23
unexpand
File
38.21 KB
0755
2018-01-18 09:43:49
uniq
File
42.21 KB
0755
2018-01-18 09:43:49
unlink
File
30.18 KB
0755
2018-01-18 09:43:49
unshare
File
18.27 KB
0755
2020-09-16 18:43:15
unsquashfs
File
99.71 KB
0755
2021-09-14 08:43:17
update-alternatives
File
46.01 KB
0755
2022-05-25 11:14:56
uptime
File
10.07 KB
0755
2023-10-31 11:35:42
users
File
34.18 KB
0755
2018-01-18 09:43:49
utmpdump
File
22.07 KB
0755
2020-09-16 18:43:15
vcs-run
File
6.75 KB
0755
2018-04-13 13:07:55
vi
File
1.06 MB
0755
2025-10-02 22:59:18
view
File
1.06 MB
0755
2025-10-02 22:59:18
vim.tiny
File
1.06 MB
0755
2025-10-02 22:59:18
vmstat
File
34.09 KB
0755
2023-10-31 11:35:42
w
File
18.07 KB
0755
2023-10-31 11:35:42
w.procps
File
18.07 KB
0755
2023-10-31 11:35:42
wall
File
30.08 KB
2755
2020-09-16 18:43:15
watch
File
22.41 KB
0755
2023-10-31 11:35:42
wc
File
42.19 KB
0755
2018-01-18 09:43:49
whereis
File
26.51 KB
0755
2020-09-16 18:43:15
which
File
946 B
0755
2019-12-07 02:13:44
who
File
50.21 KB
0755
2018-01-18 09:43:49
whoami
File
30.18 KB
0755
2018-01-18 09:43:49
wpa_passphrase
File
62 KB
0755
2024-08-05 14:28:52
x86_64
File
18.34 KB
0755
2020-09-16 18:43:15
xargs
File
70.21 KB
0755
2017-11-05 17:16:48
xdg-open
File
38 B
0755
2026-02-04 00:13:23
xdg-settings
File
1.68 KB
0755
2026-02-04 00:13:23
xxd
File
18.12 KB
0755
2025-10-02 22:59:18
yes
File
30.18 KB
0755
2018-01-18 09:43:49
zdump
File
18.05 KB
0755
2026-01-30 08:03:29
0
items selected
Choose Action...
Delete Selected
Zip Selected
Unzip Selected
Execute Action
Clear Selection
© Ultimate WebShell | Auto Bypass Enabled
Create New Folder
Create New File
Edit File: tzselect
#!/bin/bash PKGVERSION="(Ubuntu GLIBC 2.27-3ubuntu1.6+esm6) " TZVERSION="2.27" REPORT_BUGS_TO="<https://bugs.launchpad.net/ubuntu/+source/glibc/+bugs>" # Ask the user about the time zone, and output the resulting TZ value to stdout. # Interact with the user via stderr and stdin. # Contributed by Paul Eggert. This file is in the public domain. # Porting notes: # # This script requires a Posix-like shell and prefers the extension of a # 'select' statement. The 'select' statement was introduced in the # Korn shell and is available in Bash and other shell implementations. # If your host lacks both Bash and the Korn shell, you can get their # source from one of these locations: # # Bash <http://www.gnu.org/software/bash/bash.html> # Korn Shell <http://www.kornshell.com/> # Public Domain Korn Shell <http://www.cs.mun.ca/~michael/pdksh/> # # For portability to Solaris 9 /bin/sh this script avoids some POSIX # features and common extensions, such as $(...) (which works sometimes # but not others), $((...)), and $10. # # This script also uses several features of modern awk programs. # If your host lacks awk, or has an old awk that does not conform to Posix, # you can use either of the following free programs instead: # # Gawk (GNU awk) <http://www.gnu.org/software/gawk/> # mawk <http://invisible-island.net/mawk/> # Specify default values for environment variables if they are unset. : ${AWK=awk} : ${TZDIR=/usr/share/zoneinfo} # Output one argument as-is to standard output. # Safer than 'echo', which can mishandle '\' or leading '-'. say() { printf '%s\n' "$1" } # Check for awk Posix compliance. ($AWK -v x=y 'BEGIN { exit 123 }') </dev/null >/dev/null 2>&1 [ $? = 123 ] || { say >&2 "$0: Sorry, your '$AWK' program is not Posix compatible." exit 1 } coord= location_limit=10 zonetabtype=zone1970 usage="Usage: tzselect [--version] [--help] [-c COORD] [-n LIMIT] Select a time zone interactively. Options: -c COORD Instead of asking for continent and then country and then city, ask for selection from time zones whose largest cities are closest to the location with geographical coordinates COORD. COORD should use ISO 6709 notation, for example, '-c +4852+00220' for Paris (in degrees and minutes, North and East), or '-c -35-058' for Buenos Aires (in degrees, South and West). -n LIMIT Display at most LIMIT locations when -c is used (default $location_limit). --version Output version information. --help Output this help. Report bugs to $REPORT_BUGS_TO." # Ask the user to select from the function's arguments, # and assign the selected argument to the variable 'select_result'. # Exit on EOF or I/O error. Use the shell's 'select' builtin if available, # falling back on a less-nice but portable substitute otherwise. if case $BASH_VERSION in ?*) : ;; '') # '; exit' should be redundant, but Dash doesn't properly fail without it. (eval 'set --; select x; do break; done; exit') </dev/null 2>/dev/null esac then # Do this inside 'eval', as otherwise the shell might exit when parsing it # even though it is never executed. eval ' doselect() { select select_result do case $select_result in "") echo >&2 "Please enter a number in range." ;; ?*) break esac done || exit } # Work around a bug in bash 1.14.7 and earlier, where $PS3 is sent to stdout. case $BASH_VERSION in [01].*) case `echo 1 | (select x in x; do break; done) 2>/dev/null` in ?*) PS3= esac esac ' else doselect() { # Field width of the prompt numbers. select_width=`expr $# : '.*'` select_i= while : do case $select_i in '') select_i=0 for select_word do select_i=`expr $select_i + 1` printf >&2 "%${select_width}d) %s\\n" $select_i "$select_word" done ;; *[!0-9]*) echo >&2 'Please enter a number in range.' ;; *) if test 1 -le $select_i && test $select_i -le $#; then shift `expr $select_i - 1` select_result=$1 break fi echo >&2 'Please enter a number in range.' esac # Prompt and read input. printf >&2 %s "${PS3-#? }" read select_i || exit done } fi while getopts c:n:t:-: opt do case $opt$OPTARG in c*) coord=$OPTARG ;; n*) location_limit=$OPTARG ;; t*) # Undocumented option, used for developer testing. zonetabtype=$OPTARG ;; -help) exec echo "$usage" ;; -version) exec echo "tzselect $PKGVERSION$TZVERSION" ;; -*) say >&2 "$0: -$opt$OPTARG: unknown option; try '$0 --help'"; exit 1 ;; *) say >&2 "$0: try '$0 --help'"; exit 1 ;; esac done shift `expr $OPTIND - 1` case $# in 0) ;; *) say >&2 "$0: $1: unknown argument"; exit 1 ;; esac # Make sure the tables are readable. TZ_COUNTRY_TABLE=$TZDIR/iso3166.tab TZ_ZONE_TABLE=$TZDIR/$zonetabtype.tab for f in $TZ_COUNTRY_TABLE $TZ_ZONE_TABLE do <"$f" || { say >&2 "$0: time zone files are not set up correctly" exit 1 } done # If the current locale does not support UTF-8, convert data to current # locale's format if possible, as the shell aligns columns better that way. # Check the UTF-8 of U+12345 CUNEIFORM SIGN URU TIMES KI. ! $AWK 'BEGIN { u12345 = "\360\222\215\205"; exit length(u12345) != 1 }' && { tmp=`(mktemp -d) 2>/dev/null` || { tmp=${TMPDIR-/tmp}/tzselect.$$ && (umask 77 && mkdir -- "$tmp") };} && trap 'status=$?; rm -fr -- "$tmp"; exit $status' 0 HUP INT PIPE TERM && (iconv -f UTF-8 -t //TRANSLIT <"$TZ_COUNTRY_TABLE" >$tmp/iso3166.tab) \ 2>/dev/null && TZ_COUNTRY_TABLE=$tmp/iso3166.tab && iconv -f UTF-8 -t //TRANSLIT <"$TZ_ZONE_TABLE" >$tmp/$zonetabtype.tab && TZ_ZONE_TABLE=$tmp/$zonetabtype.tab newline=' ' IFS=$newline # Awk script to read a time zone table and output the same table, # with each column preceded by its distance from 'here'. output_distances=' BEGIN { FS = "\t" while (getline <TZ_COUNTRY_TABLE) if ($0 ~ /^[^#]/) country[$1] = $2 country["US"] = "US" # Otherwise the strings get too long. } function abs(x) { return x < 0 ? -x : x; } function min(x, y) { return x < y ? x : y; } function convert_coord(coord, deg, minute, ilen, sign, sec) { if (coord ~ /^[-+]?[0-9]?[0-9][0-9][0-9][0-9][0-9][0-9]([^0-9]|$)/) { degminsec = coord intdeg = degminsec < 0 ? -int(-degminsec / 10000) : int(degminsec / 10000) minsec = degminsec - intdeg * 10000 intmin = minsec < 0 ? -int(-minsec / 100) : int(minsec / 100) sec = minsec - intmin * 100 deg = (intdeg * 3600 + intmin * 60 + sec) / 3600 } else if (coord ~ /^[-+]?[0-9]?[0-9][0-9][0-9][0-9]([^0-9]|$)/) { degmin = coord intdeg = degmin < 0 ? -int(-degmin / 100) : int(degmin / 100) minute = degmin - intdeg * 100 deg = (intdeg * 60 + minute) / 60 } else deg = coord return deg * 0.017453292519943296 } function convert_latitude(coord) { match(coord, /..*[-+]/) return convert_coord(substr(coord, 1, RLENGTH - 1)) } function convert_longitude(coord) { match(coord, /..*[-+]/) return convert_coord(substr(coord, RLENGTH)) } # Great-circle distance between points with given latitude and longitude. # Inputs and output are in radians. This uses the great-circle special # case of the Vicenty formula for distances on ellipsoids. function gcdist(lat1, long1, lat2, long2, dlong, x, y, num, denom) { dlong = long2 - long1 x = cos(lat2) * sin(dlong) y = cos(lat1) * sin(lat2) - sin(lat1) * cos(lat2) * cos(dlong) num = sqrt(x * x + y * y) denom = sin(lat1) * sin(lat2) + cos(lat1) * cos(lat2) * cos(dlong) return atan2(num, denom) } # Parallel distance between points with given latitude and longitude. # This is the product of the longitude difference and the cosine # of the latitude of the point that is further from the equator. # I.e., it considers longitudes to be further apart if they are # nearer the equator. function pardist(lat1, long1, lat2, long2) { return abs(long1 - long2) * min(cos(lat1), cos(lat2)) } # The distance function is the sum of the great-circle distance and # the parallel distance. It could be weighted. function dist(lat1, long1, lat2, long2) { return gcdist(lat1, long1, lat2, long2) + pardist(lat1, long1, lat2, long2) } BEGIN { coord_lat = convert_latitude(coord) coord_long = convert_longitude(coord) } /^[^#]/ { here_lat = convert_latitude($2) here_long = convert_longitude($2) line = $1 "\t" $2 "\t" $3 sep = "\t" ncc = split($1, cc, /,/) for (i = 1; i <= ncc; i++) { line = line sep country[cc[i]] sep = ", " } if (NF == 4) line = line " - " $4 printf "%g\t%s\n", dist(coord_lat, coord_long, here_lat, here_long), line } ' # Begin the main loop. We come back here if the user wants to retry. while echo >&2 'Please identify a location' \ 'so that time zone rules can be set correctly.' continent= country= region= case $coord in ?*) continent=coord;; '') # Ask the user for continent or ocean. echo >&2 'Please select a continent, ocean, "coord", or "TZ".' quoted_continents=` $AWK ' BEGIN { FS = "\t" } /^[^#]/ { entry = substr($3, 1, index($3, "/") - 1) if (entry == "America") entry = entry "s" if (entry ~ /^(Arctic|Atlantic|Indian|Pacific)$/) entry = entry " Ocean" printf "'\''%s'\''\n", entry } ' <"$TZ_ZONE_TABLE" | sort -u | tr '\n' ' ' echo '' ` eval ' doselect '"$quoted_continents"' \ "coord - I want to use geographical coordinates." \ "TZ - I want to specify the time zone using the Posix TZ format." continent=$select_result case $continent in Americas) continent=America;; *" "*) continent=`expr "$continent" : '\''\([^ ]*\)'\''` esac ' esac case $continent in TZ) # Ask the user for a Posix TZ string. Check that it conforms. while echo >&2 'Please enter the desired value' \ 'of the TZ environment variable.' echo >&2 'For example, GST-10 is a zone named GST' \ 'that is 10 hours ahead (east) of UTC.' read TZ $AWK -v TZ="$TZ" 'BEGIN { tzname = "(<[[:alnum:]+-]{3,}>|[[:alpha:]]{3,})" time = "(2[0-4]|[0-1]?[0-9])" \ "(:[0-5][0-9](:[0-5][0-9])?)?" offset = "[-+]?" time mdate = "M([1-9]|1[0-2])\\.[1-5]\\.[0-6]" jdate = "((J[1-9]|[0-9]|J?[1-9][0-9]" \ "|J?[1-2][0-9][0-9])|J?3[0-5][0-9]|J?36[0-5])" datetime = ",(" mdate "|" jdate ")(/" time ")?" tzpattern = "^(:.*|" tzname offset "(" tzname \ "(" offset ")?(" datetime datetime ")?)?)$" if (TZ ~ tzpattern) exit 1 exit 0 }' do say >&2 "'$TZ' is not a conforming Posix time zone string." done TZ_for_date=$TZ;; *) case $continent in coord) case $coord in '') echo >&2 'Please enter coordinates' \ 'in ISO 6709 notation.' echo >&2 'For example, +4042-07403 stands for' echo >&2 '40 degrees 42 minutes north,' \ '74 degrees 3 minutes west.' read coord;; esac distance_table=`$AWK \ -v coord="$coord" \ -v TZ_COUNTRY_TABLE="$TZ_COUNTRY_TABLE" \ "$output_distances" <"$TZ_ZONE_TABLE" | sort -n | sed "${location_limit}q" ` regions=`say "$distance_table" | $AWK ' BEGIN { FS = "\t" } { print $NF } '` echo >&2 'Please select one of the following' \ 'time zone regions,' echo >&2 'listed roughly in increasing order' \ "of distance from $coord". doselect $regions region=$select_result TZ=`say "$distance_table" | $AWK -v region="$region" ' BEGIN { FS="\t" } $NF == region { print $4 } '` ;; *) # Get list of names of countries in the continent or ocean. countries=`$AWK \ -v continent="$continent" \ -v TZ_COUNTRY_TABLE="$TZ_COUNTRY_TABLE" \ ' BEGIN { FS = "\t" } /^#/ { next } $3 ~ ("^" continent "/") { ncc = split($1, cc, /,/) for (i = 1; i <= ncc; i++) if (!cc_seen[cc[i]]++) cc_list[++ccs] = cc[i] } END { while (getline <TZ_COUNTRY_TABLE) { if ($0 !~ /^#/) cc_name[$1] = $2 } for (i = 1; i <= ccs; i++) { country = cc_list[i] if (cc_name[country]) { country = cc_name[country] } print country } } ' <"$TZ_ZONE_TABLE" | sort -f` # If there's more than one country, ask the user which one. case $countries in *"$newline"*) echo >&2 'Please select a country' \ 'whose clocks agree with yours.' doselect $countries country=$select_result;; *) country=$countries esac # Get list of names of time zone rule regions in the country. regions=`$AWK \ -v country="$country" \ -v TZ_COUNTRY_TABLE="$TZ_COUNTRY_TABLE" \ ' BEGIN { FS = "\t" cc = country while (getline <TZ_COUNTRY_TABLE) { if ($0 !~ /^#/ && country == $2) { cc = $1 break } } } /^#/ { next } $1 ~ cc { print $4 } ' <"$TZ_ZONE_TABLE"` # If there's more than one region, ask the user which one. case $regions in *"$newline"*) echo >&2 'Please select one of the following' \ 'time zone regions.' doselect $regions region=$select_result;; *) region=$regions esac # Determine TZ from country and region. TZ=`$AWK \ -v country="$country" \ -v region="$region" \ -v TZ_COUNTRY_TABLE="$TZ_COUNTRY_TABLE" \ ' BEGIN { FS = "\t" cc = country while (getline <TZ_COUNTRY_TABLE) { if ($0 !~ /^#/ && country == $2) { cc = $1 break } } } /^#/ { next } $1 ~ cc && $4 == region { print $3 } ' <"$TZ_ZONE_TABLE"` esac # Make sure the corresponding zoneinfo file exists. TZ_for_date=$TZDIR/$TZ <"$TZ_for_date" || { say >&2 "$0: time zone files are not set up correctly" exit 1 } esac # Use the proposed TZ to output the current date relative to UTC. # Loop until they agree in seconds. # Give up after 8 unsuccessful tries. extra_info= for i in 1 2 3 4 5 6 7 8 do TZdate=`LANG=C TZ="$TZ_for_date" date` UTdate=`LANG=C TZ=UTC0 date` TZsec=`expr "$TZdate" : '.*:\([0-5][0-9]\)'` UTsec=`expr "$UTdate" : '.*:\([0-5][0-9]\)'` case $TZsec in $UTsec) extra_info=" Selected time is now: $TZdate. Universal Time is now: $UTdate." break esac done # Output TZ info and ask the user to confirm. echo >&2 "" echo >&2 "The following information has been given:" echo >&2 "" case $country%$region%$coord in ?*%?*%) say >&2 " $country$newline $region";; ?*%%) say >&2 " $country";; %?*%?*) say >&2 " coord $coord$newline $region";; %%?*) say >&2 " coord $coord";; *) say >&2 " TZ='$TZ'" esac say >&2 "" say >&2 "Therefore TZ='$TZ' will be used.$extra_info" say >&2 "Is the above information OK?" doselect Yes No ok=$select_result case $ok in Yes) break esac do coord= done case $SHELL in *csh) file=.login line="setenv TZ '$TZ'";; *) file=.profile line="TZ='$TZ'; export TZ" esac test -t 1 && say >&2 " You can make this change permanent for yourself by appending the line $line to the file '$file' in your home directory; then log out and log in again. Here is that TZ value again, this time on standard output so that you can use the $0 command in shell scripts:" say "$TZ"
Rename
Change Permissions
Common permissions: 755 (rwxr-xr-x), 644 (rw-r--r--), 777 (rwxrwxrwx)
System Information
Uname: Linux Stag-Enterprise-Staging-20-04 5.11.0-1019-aws #20~20.04.1-Ubuntu SMP Tue Sep 21 10:40:39 UTC 2021 x86_64 Software: Apache PHP Version: 7.4.3-4ubuntu2.29 Protocol: HTTP/1.1 Server IP: 172.31.9.152 Your IP: 216.73.216.254 Mail: ON Curl: ON Owner: www-data MySQL: ON Disabled Functions: pcntl_alarm,pcntl_fork,pcntl_waitpid,pcntl_wait,pcntl_wifexited,pcntl_wifstopped,pcntl_wifsignaled,pcntl_wifcontinued,pcntl_wexitstatus,pcntl_wtermsig,pcntl_wstopsig,pcntl_signal,pcntl_signal_get_handler,pcntl_signal_dispatch,pcntl_get_last_error,pcntl_strerror,pcntl_sigprocmask,pcntl_sigwaitinfo,pcntl_sigtimedwait,pcntl_exec,pcntl_getpriority,pcntl_setpriority,pcntl_async_signals,pcntl_unshare, Auto Bypass: ENABLED